//---------------------------------------------------------------------------
#include <vcl.h>
#include <math.h>
#pragma hdrstop

#include "ezplay.h"
#include "debug.h"
#include "ezthread.h"
#include "ezrtsp.h"
#include "orm.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TForm1 *Form1;

//- CONSTANTES --------------------------------------------------------------
#define EZ_SEEK_INTERVAL 50000000
#define EZ_VERSION 0.1
#define EZ_ZOOM 16
#define EZ_RATE 0.2
#define EZ_UDP_BUFFER 4096

//- MACROS ------------------------------------------------------------------
#define MEDIAT_TO_SEC(x) ((int)(x/10000000))
#define POURCENTAGE(x,max) (((float)(x))/((float)(max)))*100
#define VOLUMEPC_TO_VOLUMELOG(x) 10000*(    pow(  10  ,(-(x))/75  )          )

//- FONCTIONS D'INITIALISATION ----------------------------------------------

__fastcall TForm1::TForm1(TComponent* Owner)
	: TForm(Owner)
{
        // Chargement des prfrences
	ini = new TIniFile(ChangeFileExt(Application->ExeName,".ini"));
	opt_skin = ini->ReadString("Interface","Skin","leet");
	opt_fullscreen = ini->ReadBool("Interface","Fullscreen",false);
	opt_maximize = ini->ReadBool("Interface","Maximize",false);
	opt_light = ini->ReadBool("Interface","Light",false);
	opt_console = ini->ReadBool("Interface","Console",false);
	this->Top = ini->ReadInteger("Interface","Top",(Screen->WorkAreaHeight/2)-(this->Height/2)+50);
	this->Left = ini->ReadInteger("Interface","Left",(Screen->WorkAreaWidth/2)-(this->Width/2));
	this->Width = ini->ReadInteger("Interface","Width",550);
	this->Height = ini->ReadInteger("Interface","Height",400);
        media_volume_pourcent = ini->ReadInteger("Media","Volume",0);
        media_balance = ini->ReadInteger("Media","Balance",0);
	media_url = ini->ReadString("Media","LastURL","");
	OpenDialog->InitialDir=ini->ReadString("Media","LastDir","");
	rtsp_file=ini->ReadString("Rtsp","LastFile","");
	rtsp_server=ini->ReadString("Rtsp","LastServer","");
	rtsp_port=ini->ReadString("Rtsp","LastPort","");
	delete ini;
	LoadSkin(opt_skin);
        SetPosition(0);
        SetDuration(0);
        SetStatus(EZ_CLOSED);
        bytes_received=0;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormCreate(TObject *Sender)
{
        // Cration de la fentre

	// Trayicon
	icone = new Graphics::TIcon();
	ni.cbSize = sizeof(NOTIFYICONDATA);
	ni.hWnd = this->Handle;
	ni.uID = 0;
	ni.hIcon = Application->Icon->Handle;
	ni.uCallbackMessage = AM_CALLBACK_MESSAGE;
	ni.uFlags = NIF_ICON | NIF_MESSAGE;
	Shell_NotifyIcon( NIM_ADD,&ni);

	// Activation des options
	SwitchLight(opt_light);
	SwitchMaximize(opt_maximize);
	SwitchFullScreen(opt_fullscreen);
	SwitchAlwaysOnTop(opt_alwaysontop);
        drag=false;

}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormShow(TObject *Sender)
{
        // Lorsque la fentre est montre
        UpdateSlider();
        UpdateVolume();
	SwitchConsole(opt_console);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormClose(TObject *Sender, TCloseAction &Action)
{
        // Fermeture de la fentre
        if(ezr!=NULL) delete ezr;
        if(ezt!=NULL) delete ezt;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::LoadSkin(AnsiString skin) {

	// Initialisation des bitmaps (skin)
	if(BitmapBg==NULL) BitmapBg = new Graphics::TBitmap();
	if(BitmapPlay==NULL) BitmapPlay = new Graphics::TBitmap();
	if(BitmapPlayHover==NULL) BitmapPlayHover = new Graphics::TBitmap();
	if(BitmapPlayClick==NULL) BitmapPlayClick = new Graphics::TBitmap();
	if(BitmapStop==NULL) BitmapStop = new Graphics::TBitmap();
	if(BitmapStopHover==NULL) BitmapStopHover = new Graphics::TBitmap();
	if(BitmapStopClick==NULL) BitmapStopClick = new Graphics::TBitmap();
	if(BitmapPause==NULL) BitmapPause = new Graphics::TBitmap();
	if(BitmapPauseHover==NULL) BitmapPauseHover = new Graphics::TBitmap();
	if(BitmapPauseClick==NULL) BitmapPauseClick = new Graphics::TBitmap();
	if(BitmapExit==NULL) BitmapExit = new Graphics::TBitmap();
	if(BitmapExitHover==NULL) BitmapExitHover = new Graphics::TBitmap();
	if(BitmapTop==NULL) BitmapTop = new Graphics::TBitmap();
	if(BitmapTopRight==NULL) BitmapTopRight = new Graphics::TBitmap();
	if(BitmapTopLeft==NULL) BitmapTopLeft = new Graphics::TBitmap();
	if(BitmapReduce==NULL) BitmapReduce = new Graphics::TBitmap();
	if(BitmapReduceHover==NULL) BitmapReduceHover = new Graphics::TBitmap();
	if(BitmapLeft==NULL) BitmapLeft = new Graphics::TBitmap();
	if(BitmapRight==NULL) BitmapRight = new Graphics::TBitmap();
	if(BitmapBottomRight==NULL) BitmapBottomRight = new Graphics::TBitmap();
	if(BitmapBottomLeft==NULL) BitmapBottomLeft = new Graphics::TBitmap();
	if(BitmapBottom==NULL) BitmapBottom = new Graphics::TBitmap();
	if(BitmapFullscreen==NULL) BitmapFullscreen = new Graphics::TBitmap();
	if(BitmapFullscreenHover==NULL) BitmapFullscreenHover = new Graphics::TBitmap();
	if(BitmapSlider==NULL) BitmapSlider = new Graphics::TBitmap();
	if(BitmapSeeker==NULL) BitmapSeeker = new Graphics::TBitmap();
	if(BitmapVolumeSlider==NULL) BitmapVolumeSlider = new Graphics::TBitmap();
	if(BitmapVolumeSeeker==NULL) BitmapVolumeSeeker = new Graphics::TBitmap();
	if(BitmapNext==NULL) BitmapNext = new Graphics::TBitmap();
	if(BitmapNextHover==NULL) BitmapNextHover = new Graphics::TBitmap();
	if(BitmapNextClick==NULL) BitmapNextClick = new Graphics::TBitmap();
	if(BitmapPrev==NULL) BitmapPrev = new Graphics::TBitmap();
	if(BitmapPrevHover==NULL) BitmapPrevHover = new Graphics::TBitmap();
	if(BitmapPrevClick==NULL) BitmapPrevClick = new Graphics::TBitmap();

	// Ouverture du fichier ini
	ini = new TIniFile("skins/"+skin+"/skin.ini");

	//LoadSkinElement("Play",skin);

	// Chargement des bitmaps du skin

	BitmapBg->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Bg","File","bg.bmp"));
	BitmapPlay->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Play","File","play.bmp"));
	BitmapStop->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Stop","File","stop.bmp"));
	BitmapPause->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Pause","File","pause.bmp"));
	//BitmapNext->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Next","File","next.bmp"));
	//BitmapPrev->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Prev","File","prev.bmp"));
	BitmapExit->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Exit","File","exit.bmp"));
	BitmapTop->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Top","File","top.bmp"));
	BitmapTopRight->LoadFromFile("skins/"+skin+"/"+ini->ReadString("TopRight","File","topright.bmp"));
	BitmapTopLeft->LoadFromFile("skins/"+skin+"/"+ini->ReadString("TopLeft","File","topleft.bmp"));
	BitmapReduce->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Reduce","File","reduce.bmp"));
	BitmapLeft->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Left","File","left.bmp"));
	BitmapRight->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Right","File","right.bmp"));
	BitmapBottomRight->LoadFromFile("skins/"+skin+"/"+ini->ReadString("BottomRight","File","bottomright.bmp"));
	BitmapBottomLeft->LoadFromFile("skins/"+skin+"/"+ini->ReadString("BottomLeft","File","bottomleft.bmp"));
	BitmapBottom->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Bottom","File","bottom.bmp"));
	BitmapFullscreen->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Fullscreen","File","fullscreen.bmp"));

	// Bitmaps non affichs au dpart
	BitmapPlayHover->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Play","FileHover","playhover.bmp"));
	BitmapPlayClick->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Play","FileClick","playclick.bmp"));
	BitmapStopHover->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Stop","FileHover","stophover.bmp"));
	BitmapStopClick->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Stop","FileClick","stopclick.bmp"));
	BitmapPauseHover->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Pause","FileHover","pausehover.bmp"));
	BitmapPauseClick->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Pause","FileClick","pauseclick.bmp"));
	BitmapExitHover->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Exit","FileHover","exithover.bmp"));
	BitmapReduceHover->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Reduce","FileHover","reducehover.bmp"));
	//BitmapNextHover->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Next","FileHover","nexthover.bmp"));
	//BitmapNextClick->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Next","FileClick","nextclick.bmp"));
	//BitmapPrevHover->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Prev","FileHover","prevhover.bmp"));
	//BitmapPrevClick->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Prev","FileClick","prevclick.bmp"));
	BitmapFullscreenHover->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Fullscreen","FileHover","fullscreen.bmp"));
	BitmapSlider->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Slider","File","slider.bmp"));
	BitmapSeeker->LoadFromFile("skins/"+skin+"/"+ini->ReadString("Seeker","File","seeker.bmp"));
	BitmapVolumeSlider->LoadFromFile("skins/"+skin+"/"+ini->ReadString("VolumeSlider","File","volumeslider.bmp"));
	BitmapVolumeSeeker->LoadFromFile("skins/"+skin+"/"+ini->ReadString("VolumeSeeker","File","volumeseeker.bmp"));

	delete ini;

	// Attribution
	Image->Picture->Bitmap = BitmapBg;
	ImagePlay->Picture->Graphic = BitmapPlay;
	ImageStop->Picture->Graphic = BitmapStop;
	ImagePause->Picture->Graphic = BitmapPause;
	//ImageNext->Picture->Graphic = BitmapNext;
	//ImagePrev->Picture->Graphic = BitmapPrev;
	ImageExit->Picture->Graphic = BitmapExit;
	ImageTop->Picture->Graphic = BitmapTop;
	ImageTopRight->Picture->Graphic = BitmapTopRight;
	ImageTopLeft->Picture->Graphic = BitmapTopLeft;
	ImageReduce->Picture->Graphic = BitmapReduce;
	ImageLeft->Picture->Graphic = BitmapLeft;
	ImageRight->Picture->Graphic = BitmapRight;
	ImageBottomRight->Picture->Graphic = BitmapBottomRight;
	ImageBottomLeft->Picture->Graphic = BitmapBottomLeft;
	ImageBottom->Picture->Graphic = BitmapBottom;
	ImageFullscreen->Picture->Graphic = BitmapFullscreen;
        ImageSlider->Picture->Graphic = BitmapSlider;
        ImageSeeker->Picture->Graphic = BitmapSeeker;
        ImageVolumeSlider->Picture->Graphic = BitmapVolumeSlider;
        ImageVolumeSeeker->Picture->Graphic = BitmapVolumeSeeker;

}
//---------------------------------------------------------------------------

bool __fastcall TForm1::LoadSkinElement(AnsiString s, AnsiString skin) {
	/*
	AnsiString tmps;
        tmps = ini->ReadString(s,"Type",NULL);
	if(tmps=="button") {
		TImage *ImageTmp;
		ImageTmp->Parent = (TWinControl*) ImageBottomLeft;
		Graphics::TBitmap *BitmapTmp = new Graphics::TBitmap();
		tmps = ini->ReadString(s,"Parent","");
		if(!tmps.IsEmpty()) {
			Image[s]->Parent=tmps;
		}
		tmps = ini->ReadString(s,"File","");
		if(!tmps.IsEmpty()) {
			BitmapTmp->LoadFromFile("skins/"+skin+"/"+tmps);
		}
		tmps = ini->ReadString(s,"FileHover","");
		if(!tmps.IsEmpty()) {
			Graphics::TBitmap *Bitmap[shover] = new Graphics::TBitmap();
			Bitmap[shover]->LoadFromFile("skins/"+skin+"/"+tmps);
		}
		tmps = ini->ReadString(s,"FileClick","");
		if(!tmps.IsEmpty()) {
			Graphics::TBitmap *Bitmap[sclick] = new Graphics::TBitmap();
			Bitmap[sclick]->LoadFromFile("skins/"+skin+"/"+tmps);
		}
		ImageTmp->Picture->Graphic = BitmapTmp;
		ImageTmp->Width = ini->ReadInteger(s,"Width",0);
		ImageTmp->Height = ini->ReadInteger(s,"Height",0);
		ImageTmp->Top = ini->ReadInteger(s,"Top",0);
                ImageTmp->Left = ini->ReadInteger(s,"Left",0);
                // Anchors
                // OnClick
                // Onmouseover
	}*/
	return true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormDestroy(TObject *Sender)
{
	// Trayicon
	delete icone;
	Shell_NotifyIcon(NIM_DELETE, &ni);

	// Mmorisation des prfrences
	ini = new TIniFile(ChangeFileExt(Application->ExeName,".ini"));
	ini->WriteString("Interface","Skin",opt_skin);
	ini->WriteBool("Interface","Fullscreen",opt_fullscreen);
	ini->WriteBool("Interface","Maximize",opt_maximize);
	ini->WriteBool("Interface","Alwaysontop",opt_alwaysontop);
	ini->WriteBool("Interface","Console",opt_console);
	ini->WriteBool("Interface","Light",opt_light);
	if(!opt_fullscreen) {
		ini->WriteInteger("Interface","Top",this->Top);
		ini->WriteInteger("Interface","Left",this->Left);
		ini->WriteInteger("Interface","Width",this->Width);
		ini->WriteInteger("Interface","Height",this->Height);
	}
	ini->WriteString("Media","LastURL",media_url);
	ini->WriteString("Media","LastDir",OpenDialog->InitialDir);
        ini->WriteInteger("Media","Volume",media_volume_pourcent);
        ini->WriteInteger("Media","Balance",media_balance);
	ini->WriteString("Rtsp","LastFile",rtsp_file);
	ini->WriteString("Rtsp","LastServer",rtsp_server);
	ini->WriteString("Rtsp","LastPort",rtsp_port);
	delete ini;

}
//---------------------------------------------------------------------------






//- FONCTIONS D'INTERFACE (Dialogues et boutons) ----------------------------

void __fastcall TForm1::ImageTopLeftDblClick(TObject *Sender)
{
	SwitchFullScreen(!opt_fullscreen);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageDblClick(TObject *Sender)
{
	SwitchFullScreen(!opt_fullscreen);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageTopDblClick(TObject *Sender)
{
	SwitchMaximize(!opt_maximize);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageFullscreenClick(TObject *Sender)
{
	SwitchFullScreen(!opt_fullscreen);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SwitchLight(bool v=false) {
	// Switch fentre light
	if(v) {
		PanelTop->Visible=false;
		ImageRight->Visible=false;
		PanelBottom->Visible=false;
		ImageLeft->Visible=false;
		opt_light=true;
	} else {
		PanelTop->Visible=true;
		ImageRight->Visible=true;
		PanelBottom->Visible=true;
		ImageLeft->Visible=true;
		opt_light=false;
	}
	UpdateRect();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SwitchAlwaysOnTop(bool v=false) {
	// Switch fentre toujours au top
	if(v) {
		Form1->FormStyle=fsStayOnTop;
		opt_alwaysontop=true;
	} else {
		Form1->FormStyle=fsNormal;
		opt_alwaysontop=false;
	}
        UpdateRect();
        if(ezt!=NULL) ezt->ReInit();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SwitchMaximize(bool v=false) {
	// Switch fentre maximise
	if(v) {
		Form1->WindowState=wsMaximized;
		opt_maximize=true;
	} else {
		Form1->WindowState=wsNormal;
		opt_maximize=false;
	}
        UpdateRect();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SwitchConsole(bool v=false) {
	// Affichage console
	tmp=Form1->Focused(); // Mmorisation du focus
	if(v) {
		FormDebug->Show();
		opt_console=true;
	} else {
		FormDebug->Hide();
		opt_console=false;
	}
	if(tmp) Form1->Show(); // Rtablissement du focus
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SwitchFullScreen(bool v=false) {
	// Switch plein cran
	if(v) {
		PanelTop->Visible=false;
		ImageRight->Visible=false;
		PanelBottom->Visible=false;
		ImageLeft->Visible=false;
		Form1->WindowState=wsMaximized;
		opt_fullscreen=true;
	} else {
		PanelTop->Visible=true;
		ImageRight->Visible=true;
		PanelBottom->Visible=true;
		ImageLeft->Visible=true;
		Form1->WindowState=wsNormal;
		opt_fullscreen=false;
	}
        UpdateRect();
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Move() {
	// Dplacer la fentre
	if(Form1->WindowState!=wsMaximized) {
		ReleaseCapture();
		SendMessage(Handle, WM_SYSCOMMAND, 0xF012, 0);
	}
}

//---------------------------------------------------------------------------

void __fastcall TForm1::Refresh() {
	// Rafrachit les bitmaps par dfaut lorsque la souris quitte un hover

	switch(mouseover) {
		case EZ_MOUSEOVER_EXIT:
			ImageExit->Picture->Graphic = BitmapExitHover;
		break;
		case EZ_MOUSEOVER_PLAY:
			ImagePlay->Picture->Graphic = BitmapPlayHover;
		break;
		case EZ_MOUSEOVER_STOP:
			ImageStop->Picture->Graphic = BitmapStopHover;
		break;
		case EZ_MOUSEOVER_PAUSE:
			ImagePause->Picture->Graphic = BitmapPauseHover;
		break;
		case EZ_MOUSEOVER_REDUCE:
			ImageReduce->Picture->Graphic = BitmapReduceHover;
		break;
		case EZ_MOUSEOVER_FULLSCREEN:
			ImageFullscreen->Picture->Graphic = BitmapFullscreenHover;
		break;
		case EZ_MOUSEOVER_NEXT:
			ImageNext->Picture->Graphic = BitmapNextHover;
		break;
		case EZ_MOUSEOVER_PREV:
			ImagePrev->Picture->Graphic = BitmapPrevHover;
		break;
	}
	switch(last_mouseover) {
		case EZ_MOUSEOVER_EXIT:
			if(mouseover!=EZ_MOUSEOVER_EXIT) ImageExit->Picture->Graphic = BitmapExit;
		break;
		case EZ_MOUSEOVER_PLAY:
			if(mouseover!=EZ_MOUSEOVER_PLAY) ImagePlay->Picture->Graphic = BitmapPlay;
		break;
		case EZ_MOUSEOVER_STOP:
			if(mouseover!=EZ_MOUSEOVER_STOP) ImageStop->Picture->Graphic = BitmapStop;
		break;
		case EZ_MOUSEOVER_PREV:
			if(mouseover!=EZ_MOUSEOVER_PREV) ImagePrev->Picture->Graphic = BitmapPrev;
		break;
		case EZ_MOUSEOVER_NEXT:
			if(mouseover!=EZ_MOUSEOVER_NEXT) ImageNext->Picture->Graphic = BitmapNext;
		break;
		case EZ_MOUSEOVER_PAUSE:
			if(mouseover!=EZ_MOUSEOVER_PAUSE) ImagePause->Picture->Graphic = BitmapPause;
		break;
		case EZ_MOUSEOVER_REDUCE:
			if(mouseover!=EZ_MOUSEOVER_REDUCE) ImageReduce->Picture->Graphic = BitmapReduce;
		break;
		case EZ_MOUSEOVER_FULLSCREEN:
			if(mouseover!=EZ_MOUSEOVER_FULLSCREEN) ImageFullscreen->Picture->Graphic = BitmapFullscreen;
		break;
	}
	last_mouseover=mouseover;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::SetStatus(short s) {
	// Met  jour le status
        status=s;
        switch(s) {
                case EZ_PLAYING:
                        LabelStatus->Caption="Playing";
                break;
                case EZ_CLOSED:
                        LabelStatus->Caption="Closed";
                break;
                case EZ_PAUSED:
                        LabelStatus->Caption="Paused";
                break;
                case EZ_READY:
                        LabelStatus->Caption="Ready";
                break;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Console(AnsiString str) {
	// Ajoute une ligne dans la console
        if(FormDebug!=NULL) FormDebug->Memo->Lines->Add(str);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageExitClick(TObject *Sender)
{
	Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageReduceClick(TObject *Sender)
{
	Application->Minimize();
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageNextMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	mouseover=EZ_MOUSEOVER_NEXT;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImagePrevMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	mouseover=EZ_MOUSEOVER_PREV;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImagePlayMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	mouseover=EZ_MOUSEOVER_PLAY;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageExitMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_EXIT;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageFullscreenMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	if(mouseover==EZ_MOUSEOVER_NONE) {
		mouseover = EZ_MOUSEOVER_FULLSCREEN;
		Refresh();
	}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageStopMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_STOP;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImagePauseMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_PAUSE;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageReduceMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	if(mouseover==EZ_MOUSEOVER_NONE) {
		mouseover = EZ_MOUSEOVER_REDUCE;
		Refresh();
	}
}
//---------------------------------------------------------------------------


void __fastcall TForm1::ImageLeftMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	// Redimensionner la fentre H
	ReleaseCapture();
	SendMessage(Handle, WM_SYSCOMMAND, 0xF001, 0);
        UpdateRect();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageRightMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	// Redimensionner la fentre H
	ReleaseCapture();
	SendMessage(Handle, WM_SYSCOMMAND, 0xF002, 0);
        UpdateRect();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageResizeMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	// Redimensionner la fentre V+H
	ReleaseCapture();
	SendMessage(Handle, WM_SYSCOMMAND, 0xF008, 0);
        UpdateRect();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageTopLeftMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Move();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageBottomMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Move();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageBottomLeftMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Move();	
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageBottomRightMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Move();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PanelDisplayMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Move();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Move();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageTopMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Move();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseDown(TObject *Sender, TMouseButton Button,
	  TShiftState Shift, int X, int Y)
{
	Move();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageTopRightMouseDown(TObject *Sender,
	  TMouseButton Button, TShiftState Shift, int X, int Y)
{
	Move();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageTopLeftMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_NONE;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageBottomLeftMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_NONE;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageBottomMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_NONE;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageBottomRightMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_NONE;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageTopRightMouseMove(TObject *Sender,
	  TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_NONE;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageTopMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	mouseover = EZ_MOUSEOVER_NONE;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageMouseMove(TObject *Sender, TShiftState Shift,
      int X, int Y)
{
	mouseover = EZ_MOUSEOVER_NONE;
	Refresh();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PanelDisplayClick(TObject *Sender)
{
	//Pause(); bug
}
//---------------------------------------------------------------------------

void __fastcall TForm1::TimerTimer(TObject *Sender)
{
        // Actualisation de l'affichage du temps
        UpdateSlider();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpdateSlider()
{
        if(!drag) {
                SetPosition(media_position);
                // Affichage du temps
                tmps.sprintf("%02d:%02d / %02d:%02d",media_position_m,media_position_s,media_duration_m,media_duration_s);
                LabelTime->Caption=tmps;
                // Calcul de l'espace du slider/seeker
                seeker_min=ImageSlider->Left;
                seeker_max=seeker_min+ImageSlider->Width-ImageSeeker->Width;
                // Modification de la position slider
                if(media_position>0 && media_duration>0) {
                        media_pos=POURCENTAGE(media_position,media_duration); // calcul en %
                } else {
                        media_pos=0;
                }
                // Console("Position : "+AnsiString(media_pos).SubString(0,5)+"%");
                ImageSeeker->Left=seeker_min+(seeker_max-seeker_min)*(media_pos/100); // calcul en pixels

                // Si mode rtsp et en train de play on affiche les bytes reus dans la console
                if(ez_mode==EZ_MODE_RTSP && status==EZ_PLAYING) {
                        if(bytes_received>0) Console(bytes_received);
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpdateVolume()
{
        if(!drag) {
                // Calcul de l'espace du volume slider/seeker
                volume_seeker_min=ImageVolumeSlider->Left;
                volume_seeker_max=volume_seeker_min+ImageVolumeSlider->Width-ImageVolumeSeeker->Width;
                // Modification de la position volume slider
                ImageVolumeSeeker->Left=volume_seeker_min+(volume_seeker_max-volume_seeker_min)*((float)media_volume_pourcent/100); // calcul en pixels
        }
        // Calcul du volume et attribution
        if(media_volume_pourcent==0) {
                media_volume=10000; // Fakage du volume zero parfait
        } else {
                media_volume = VOLUMEPC_TO_VOLUMELOG((float)media_volume_pourcent)-464;
        }
        Console("Volume ["+AnsiString(media_volume_pourcent)+"% -"+AnsiString(media_volume)+" dB]");
        if(ezt!=NULL) ezt->SetAudio(media_volume,media_balance);
}
//---------------------------------------------------------------------------







//- FONCTIONS DE MENU CONTEXTUEL -------------------------------------------

void __fastcall TForm1::PopupMenuExitClick(TObject *Sender)
{
	// Quitte le programme
	Application->Terminate();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuAboutClick(TObject *Sender)
{
	// Montrer l'About
	Console("EzPlayer by dew & manw");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuAlwaysontopClick(TObject *Sender)
{
	SwitchAlwaysOnTop(!opt_alwaysontop);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuLightClick(TObject *Sender)
{
	SwitchLight(!opt_light);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuFullScreenClick(TObject *Sender)
{
	SwitchFullScreen(!opt_fullscreen);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuSkinReloadClick(TObject *Sender)
{
	LoadSkin(opt_skin);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuSkinLeetClick(TObject *Sender)
{
	opt_skin="leet";
	LoadSkin(opt_skin);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuSkinMetalClick(TObject *Sender)
{
	opt_skin="metal";
	LoadSkin(opt_skin);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuOpenMediaClick(TObject *Sender)
{
        OpenMedia();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuRemoteMediaClick(TObject *Sender)
{
        OpenRemoteMedia();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PanelDisplayDblClick(TObject *Sender)
{
	SwitchFullScreen(!opt_fullscreen);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuPopup(TObject *Sender)
{
	if(opt_skin=="metal") PopupMenuSkinMetal->Checked=true; else PopupMenuSkinMetal->Checked=false;
	if(opt_skin=="leet") PopupMenuSkinLeet->Checked=true; else PopupMenuSkinLeet->Checked=false;
	PopupMenuAlwaysontop->Checked=opt_alwaysontop;
	PopupMenuConsole->Checked=opt_console;
	PopupMenuLight->Checked=opt_light;
	PopupMenuLight->Enabled=!opt_fullscreen;
	PopupMenuFullScreen->Checked=opt_fullscreen;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuConsoleClick(TObject *Sender)
{
	SwitchConsole(!opt_console);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopuMenuZoomResetClick(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->RectZoomX(0);
			ezt->RectZoomY(0);
			Console("Zoom Reset");
		}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuZoom1Click(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->RectZoomX(EZ_ZOOM);
			ezt->RectZoomY(EZ_ZOOM);
			Console("Zoom +");
			PanelDisplay->Invalidate(); // Pour viter les leaks de l'overlay
		}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuZoom2Click(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->RectZoomX(-EZ_ZOOM);
			ezt->RectZoomY(-EZ_ZOOM);
			Console("Zoom -");
			PanelDisplay->Invalidate(); // Pour viter les leaks de l'overlay
		}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuZoomX1Click(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->RectZoomX(EZ_ZOOM);
			Console("Zoom X+");
		}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuZoomX2Click(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->RectZoomX(-EZ_ZOOM);
			Console("Zoom X-");
		}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuZoomY1Click(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->RectZoomY(EZ_ZOOM);
			Console("Zoom Y+");
		}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuZoomY2Click(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->RectZoomY(-EZ_ZOOM);
			Console("Zoom Y-");
		}
}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuRate1Click(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->UpdateRate(EZ_RATE);
			Console("Rate +");
		}

}
//---------------------------------------------------------------------------

void __fastcall TForm1::PopupMenuRate2Click(TObject *Sender)
{
		if(ezt!=NULL) {
			ezt->UpdateRate(-EZ_RATE);
			Console("Rate -");
		}
}
//---------------------------------------------------------------------------













//- EVENEMENTS UTILISATEUR---------------------------------------------------

void __fastcall TForm1::FormKeyPress(TObject *Sender, char &Key)
{
        // Raccourcis clavier
	if(Key=='o' || Key=='O') {
                OpenMedia();
	} else if(Key=='r' || Key=='R') {
		OpenRemoteMedia();
	} else if(Key=='z' || Key=='Z') {
		SwitchFullScreen(!opt_fullscreen);
	} else if(Key=='a' || Key=='A') {
		SwitchAlwaysOnTop(!opt_alwaysontop);
	} else if(Key=='c' || Key=='C') {
		SwitchConsole(!opt_console);
	} else if(Key=='l' || Key=='L') {
		SwitchLight(!opt_light);
	} else if(Key=='m' || Key=='M') {
		if(ezt!=NULL) {
			if(ezt->Mute())
			Console("Mute");
                }
	} else if(Key==' ') {
                if(status==EZ_PLAYING) {
                        Pause();
                } else if(status==EZ_PAUSED) {
			Play();
                } else if(status==EZ_READY) {
                        Play();
                }
	} else if(Key=='p' || Key=='P') {
                Play();
        } else if(Key=='s' || Key=='S') {
		Stop();
        } else if(Key=='8') {
		if(ezt!=NULL) {
			ezt->RectZoomY(EZ_ZOOM);
			Console("Zoom Y+");
		}
	} else if(Key=='6') {
		if(ezt!=NULL) {
			ezt->RectZoomX(EZ_ZOOM);
			Console("Zoom X+");
		}
	} else if(Key=='4') {
		if(ezt!=NULL) {
			ezt->RectZoomY(-EZ_ZOOM);
			Console("Zoom Y-");
		}
	} else if(Key=='2') {
		if(ezt!=NULL) {
			ezt->RectZoomX(-EZ_ZOOM);
			Console("Zoom X-");
		}
	} else if(Key=='5') {
		if(ezt!=NULL) {
			ezt->RectZoomX(0);
			ezt->RectZoomY(0);
			Console("Zoom Reset");
		}
	} else if(Key=='+') {
		if(ezt!=NULL) {
			ezt->RectZoomX(EZ_ZOOM);
			ezt->RectZoomY(EZ_ZOOM);
			Console("Zoom +");
			PanelDisplay->Invalidate(); // Pour viter les leaks de l'overlay
		}
	} else if(Key=='-') {
		if(ezt!=NULL) {
			ezt->RectZoomX(-EZ_ZOOM);
			ezt->RectZoomY(-EZ_ZOOM);
			Console("Zoom -");
			PanelDisplay->Invalidate(); // Pour viter les leaks de l'overlay
		}
	} else if(Key=='f' || Key=='F') {
		if(ezt!=NULL) {
			ezt->UpdateRate(EZ_RATE);
			Console("Rate +");
		}
	} else if(Key=='b' || Key=='B') {
		if(ezt!=NULL) {
			ezt->UpdateRate(-EZ_RATE);
			Console("Rate -");
		}
	} else {
		Console(Key);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormKeyDown(TObject *Sender, WORD &Key,
      TShiftState Shift)
{
        // Raccourcis clavier virtuels
	if(Key==VK_RIGHT) {
                // Dplace la position
                position=media_position+EZ_SEEK_INTERVAL;
                Seek(position);
        } else if(Key==VK_LEFT) {
                // Dplace la position
                position=media_position-EZ_SEEK_INTERVAL;
                Seek(position);
        } else if(Key==VK_ESCAPE && opt_fullscreen) {
                SwitchFullScreen(!opt_fullscreen);
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ImagePlayClick(TObject *Sender)
{
	ImagePlay->Picture->Graphic = BitmapPlayClick;
        Play();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageStopClick(TObject *Sender)
{
	ImageStop->Picture->Graphic = BitmapStopClick;
	Stop();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageNextClick(TObject *Sender)
{
	ImageNext->Picture->Graphic = BitmapNextClick;
	Next();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImagePrevClick(TObject *Sender)
{
	ImagePrev->Picture->Graphic = BitmapPrevClick;
	Prev();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImagePauseClick(TObject *Sender)
{
	ImagePause->Picture->Graphic = BitmapPauseClick;
        Pause();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageSeekerMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        // Lorsque l'utilisateur clique sur le slider
        if(status==EZ_PLAYING || status==EZ_PAUSED || status==EZ_READY) {
                seeker_pos_origin=ImageSeeker->Left;
                mouse_pos_origin=Mouse->CursorPos.x;
                drag=true;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageSeekerMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        // Lorsque l'utilisateur dplacer le slider
        if(drag) {
                seeker_pos = (Mouse->CursorPos.x-mouse_pos_origin)+seeker_pos_origin;
                if(seeker_pos>seeker_max) seeker_pos=seeker_max;
                if(seeker_pos<seeker_min) seeker_pos=seeker_min;
		ImageSeeker->Left=seeker_pos;
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageSeekerMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        // Lorsque l'utilisateur relche la souris du slider
        drag = false;
        media_pos = POURCENTAGE(seeker_pos-seeker_min,seeker_max-seeker_min);
        Console("SlideMouseSeek : "+AnsiString(media_pos)+" %");
        Seek(media_pos*(media_duration)/100);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageSliderClick(TObject *Sender)
{
        // Utilisateur cliquant sur le slider pour seeker
        media_pos=POURCENTAGE(Mouse->CursorPos.x-(ImageSlider->Left+Form1->Left),ImageSlider->Width);
        Console("SlideClickSeek : "+AnsiString(media_pos)+" %");
        Seek(media_pos*(media_duration)/100);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageVolumeSeekerMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        // Lorsque l'utilisateur clique sur le slider
        seeker_pos_origin=ImageVolumeSeeker->Left;
        mouse_pos_origin=Mouse->CursorPos.x;
        drag=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageVolumeSeekerMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
        // Calcul de l'espace du volume slider/seeker
        volume_seeker_min=ImageVolumeSlider->Left;
        volume_seeker_max=volume_seeker_min+ImageVolumeSlider->Width-ImageVolumeSeeker->Width;
        // Lorsque l'utilisateur dplace le volume
        if(drag) {
                volume_seeker_pos = (Mouse->CursorPos.x-mouse_pos_origin)+seeker_pos_origin;
                if(volume_seeker_pos>volume_seeker_max) volume_seeker_pos=volume_seeker_max;
                if(volume_seeker_pos<volume_seeker_min) volume_seeker_pos=volume_seeker_min;
                ImageVolumeSeeker->Left=volume_seeker_pos;
                media_volume_pourcent = POURCENTAGE(volume_seeker_pos-volume_seeker_min,volume_seeker_max-volume_seeker_min);
                UpdateVolume();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ImageVolumeSeekerMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
        // Lorsque l'utilisateur relche le volume
        drag = false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseWheelUp(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
        media_volume_pourcent+=10;
        if(media_volume_pourcent>100) media_volume_pourcent=100;
        UpdateVolume();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormMouseWheelDown(TObject *Sender,
      TShiftState Shift, TPoint &MousePos, bool &Handled)
{
        media_volume_pourcent-=10;
        if(media_volume_pourcent<0) media_volume_pourcent=0;
        UpdateVolume();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::UpdateRect() {
        // Met  jour la zone d'overlay
        if(ezt!=NULL) {
                ezt->UpdateRect();
        }
}
//---------------------------------------------------------------------------

bool __fastcall TForm1::UpdateTitle() {
        // Met  jour le titre de l'application  partir du fichier ouvert
        WORD w;
        short err;
        GlobalFree(lpszTitle);
        w = GetFileTitle(media_url.c_str(),NULL,0);
        if(w>0) {
                lpszTitle = (LPTSTR) GlobalAlloc(GPTR, sizeof(TCHAR)* w);
                if(lpszTitle) {
                        err = GetFileTitle(media_url.c_str(),lpszTitle,w);
                        if(err == 0) {
                                Application->Title = lpszTitle;
                                return true;
                        } else {
                                return false;
			}
                } else {
                        return false;
                }
        } else {
                return false;
        }
}
//---------------------------------------------------------------------------







//- FONCTIONS MEDIA ---------------------------------------------------------

void __fastcall TForm1::OpenMedia() {
        // Fichier local
        if(OpenDialog->Execute()) {
                Stop();
                Close();
                media_url=OpenDialog->FileName;
                if(FileExists(media_url)) {
                        ez_mode=EZ_MODE_LOCAL;
                        Open();
                        Play();
                } else {
                        Console("OpenMedia : !FileExists"); 
                }
        }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::OpenRemoteMedia() {
	FormORM->EditFile->Text=rtsp_file;
	FormORM->EditServer->Text=rtsp_server;
	FormORM->EditPort->Text=rtsp_port;
	FormORM->ShowModal();
	rtsp_file=FormORM->EditFile->Text;
	rtsp_server=FormORM->EditServer->Text;
	rtsp_port=FormORM->EditPort->Text;
	if(rtsp_port.Length()<1) rtsp_port="554";
	// Ouvre un flux distant
	Stop();
	Close();
	media_url="rtsp://"+rtsp_server+":"+rtsp_port+"/"+rtsp_file;
	Console("Media : "+media_url);
	ez_mode=EZ_MODE_RTSP;
	Open();
	status=EZ_PLAYING;
	// Play();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Close() {
        Console("!CLOSE");
        if(ezt!=NULL) {
                ezt->Close();
                media_url="";
                SetStatus(EZ_CLOSED);
                delete ezt;
        }
        Image->Visible=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Open() {
	Console("!OPEN");
        if(media_url.IsEmpty()) {
                Console("[OPEN] Pas d'URL spcifie");
                SetStatus(EZ_CLOSED);
        } else if(media_url.SubString(0,7)=="rtsp://") {
                Console("[MODE] RTSP");
		ez_mode=EZ_MODE_RTSP;
		StartTimer();
		ezt = new EzThread(true); // true = cr suspendu
		if(ezt!=NULL) {
			ezt->Init();
			bytes_received=0;
			ClientSocketTCP->Host=rtsp_server;
                        ClientSocketTCP->Port=rtsp_port.ToInt();
                        ClientSocketTCP->Active=true;
                        if(ezr==NULL) ezr = new EzRtsp(true);
                        buffer1 = (char*)malloc(sizeof(char)*EZ_UDP_BUFFER);
                        buffer2 = (char*)malloc(sizeof(char)*EZ_UDP_BUFFER);
                        buffer3 = (char*)malloc(sizeof(char)*EZ_UDP_BUFFER);
                        buffer4 = (char*)malloc(sizeof(char)*EZ_UDP_BUFFER);
                        if(ezr!=NULL) {
                                ezr->Init();
                                ezr->SetSocket(ClientSocketTCP);
                                ezr->SetURL(media_url);
				ezr->SetFile(rtsp_file);
                                ezr->SetHost(rtsp_server);
                                ezr->Connect();
                                SetStatus(EZ_PLAYING);
                        }
                } else {
                        Console("NewEzThread [ERR]");
                        SetStatus(EZ_CLOSED);
                }
        } else {
		Console("[MODE] LOCAL");
		ez_mode=EZ_MODE_LOCAL;
		ezt = new EzThread(true); // true = cr suspendu
                if(ezt!=NULL) {
                        ezt->Init();
                        // Ouvre le fichier local
                        lpwstrLocalFile = new wchar_t[media_url.WideCharBufSize()];
                        media_url.WideChar(lpwstrLocalFile,media_url.WideCharBufSize());
                        if(ezt->OpenFile(lpwstrLocalFile)) {
                                SetStatus(EZ_READY);
                                Console("OpenFile [OK] "+media_url);
                                UpdateTitle();
                        } else {
                                SetStatus(EZ_CLOSED);
                                Console("OpenFile [ERR]");
                        }
                        delete[] lpwstrLocalFile;
                } else {
                        Console("NewEzThread [ERR]");
                        SetStatus(EZ_CLOSED);
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Play() {
        Console("!PLAY");
	if(ezr!=NULL) {
		if(status==EZ_READY) {
			Stop();
			Close();
			media_url="rtsp://"+rtsp_server+":"+rtsp_port+"/"+rtsp_file;
			ez_mode=EZ_MODE_RTSP;
			StartTimer();
			Open();
			status=EZ_PLAYING;
		} else {
			ezr->Play();
		}
	}
        if(ezt!=NULL) {
                if(ezt->Play()) {
                        if(Image->Visible) Image->Visible=false;
			StartTimer();
                        UpdateVolume();
                        SetStatus(EZ_PLAYING);
                } else {
                        Console("[PLAY] Pas de flux vido");
                }
        } else {
		Open();
                if(status==EZ_READY) Play();
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Next() {
	Console("!NEXT");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Prev() {
	Console("!PREV");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Stop() {
	Console("!STOP");
	if(ezr!=NULL) {
                ezr->Teardown();
		StopTimer();
		SetStatus(EZ_READY);
        }
        if(ezt!=NULL) {
                if(ezt->Stop()) {
                        StopTimer();
                        SetPosition(0);
                        UpdateSlider();
                        SetStatus(EZ_READY);
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Pause() {
        Console("!PAUSE");
        if(ezr!=NULL) {
                ezr->Pause();
        }
        if(ezt!=NULL && status==EZ_PLAYING) {
                if(ezt->Pause()) {
                        SetStatus(EZ_PAUSED);
                } else {
                        Console("[PAUSE] Erreur");
                }
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SetPosition(LONGLONG position) {
        // Met  jour la position affiche
        media_position=position;
	media_position_m=MEDIAT_TO_SEC(media_position)/60;
        media_position_s=MEDIAT_TO_SEC(media_position)%60;
}

//---------------------------------------------------------------------------

void __fastcall TForm1::SetDuration(LONGLONG duration) {
        // Met  jour la dure affiche
        media_duration=duration;
        media_duration_m=MEDIAT_TO_SEC(media_duration)/60;
        media_duration_s=MEDIAT_TO_SEC(media_duration)%60;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::EndOfMedia() {
        Console("EOF");
        // Se produit lorsque la fin du media est dtecte
        ezt->Stop();
        StopTimer();
        SetStatus(EZ_READY);
        media_position=0;
        UpdateSlider();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Seek(LONGLONG pos) {
        // Vrifie qu'on est bien dans la timeline
        if(pos>media_duration) {
                pos=media_duration;
        } else if(position<0) {
                pos=0;
        }
        Console("!SEEK : "+AnsiString(media_position)+" > "+AnsiString(pos));
        SetPosition(pos);
	UpdateSlider();
        // Action de seeker
        if(ezt!=NULL) {
                ezt->Seek(pos);
        }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StartTimer() {
        Timer->Enabled=true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::StopTimer() {
        Timer->Enabled=false;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocketTCPRead(TObject *Sender,
      TCustomWinSocket *Socket)
{
	buffer = ClientSocketTCP->Socket->ReceiveText();
	Console("> "+buffer);
        if(ezr!=NULL) ezr->Received(buffer);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocketTCPConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
	// Socket connect
	Console("[SOCKET] Connected to : "+Socket->RemoteHost+" ("+Socket->RemoteAddress+":"+Socket->RemotePort+")");
	Console("[SOCKET] Local : "+Socket->LocalHost+" ("+Socket->LocalAddress+":"+Socket->LocalPort+")");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocketTCPConnecting(TObject *Sender,
      TCustomWinSocket *Socket)
{
        Console("[SOCKET] Connecting...");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocketTCPDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
        Console("[SOCKET] Disconnect");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocketTCPError(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
	Console("[SOCKET] Error");
        if(ezr!=NULL) delete ezr;
        if(ezt!=NULL) delete ezt;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ClientSocketTCPLookup(TObject *Sender,
      TCustomWinSocket *Socket)
{
        Console("[SOCKET] Lookup");
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SocketUDP1DataReceived(TComponent *Sender,
      int NumberBytes, AnsiString FromIP, int Port)
{
        //Console("UDP1 ("+AnsiString(NumberBytes)+") from "+FromIP+":"+AnsiString(Port));
        SocketUDP1->ReadBuffer(buffer1, EZ_UDP_BUFFER, j);
        bytes_received+=j;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SocketUDP2DataReceived(TComponent *Sender,
      int NumberBytes, AnsiString FromIP, int Port)
{
        //Console("UDP2 ("+AnsiString(NumberBytes)+") from "+FromIP+":"+AnsiString(Port));
        SocketUDP2->ReadBuffer(buffer2, EZ_UDP_BUFFER, j);
        bytes_received+=j;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SocketUDP3DataReceived(TComponent *Sender,
      int NumberBytes, AnsiString FromIP, int Port)
{
        //Console("UDP3 ("+AnsiString(NumberBytes)+") from "+FromIP+":"+AnsiString(Port));
        SocketUDP3->ReadBuffer(buffer3, EZ_UDP_BUFFER, j);
        bytes_received+=j;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::SocketUDP4DataReceived(TComponent *Sender,
      int NumberBytes, AnsiString FromIP, int Port)
{
        //Console("UDP4 ("+AnsiString(NumberBytes)+") from "+FromIP+":"+AnsiString(Port));
        SocketUDP4->ReadBuffer(buffer4, EZ_UDP_BUFFER, j);
        bytes_received+=j;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::FormResize(TObject *Sender)
{
	// Redimensionnement de la fentre
	UpdateRect();
}
//---------------------------------------------------------------------------


