//---------------------------------------------------------------------------

#ifndef ezplayH
#define ezplayH

#include <guiddef.h>

#include "ezthread.h"
#include "ezrtsp.h"

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <Graphics.hpp>
#include <Menus.hpp>
#include <inifiles.hpp>
#include <Dialogs.hpp>
#include <ComCtrls.hpp>
#include <NMUDP.hpp>
#include <ScktComp.hpp>

#define AM_CALLBACK_MESSAGE   WM_APP + 408

#define EZ_PLAYING 4
#define EZ_PAUSED  5
#define EZ_READY   6
#define EZ_CLOSED  7

#define EZ_MODE_LOCAL 1
#define EZ_MODE_RTSP  2

#define EZ_MOUSEOVER_NONE       0
#define EZ_MOUSEOVER_PAUSE      1
#define EZ_MOUSEOVER_PLAY       2
#define EZ_MOUSEOVER_STOP       3
#define EZ_MOUSEOVER_FULLSCREEN 4
#define EZ_MOUSEOVER_EXIT       5
#define EZ_MOUSEOVER_REDUCE     6
#define EZ_MOUSEOVER_NEXT       7
#define EZ_MOUSEOVER_PREV       8

//---------------------------------------------------------------------------
class TForm1 : public TForm
{
__published:	// Composants grs par l'EDI
        TPanel *PanelDisplay;
	TImage *Image;
	TImage *ImagePlay;
	TImage *ImageExit;
	TImage *ImageStop;
	TImage *ImagePause;
	TImage *ImageResize;
	TPanel *PanelTop;
	TPanel *PanelMiddle;
	TPanel *PanelBottom;
	TImage *ImageTop;
	TImage *ImageTopRight;
	TImage *ImageTopLeft;
	TPopupMenu *PopupMenu;
	TMenuItem *PopupMenuExit;
	TMenuItem *PopupMenuAbout;
	TImage *ImageReduce;
	TImage *ImageLeft;
	TImage *ImageRight;
	TImage *ImageBottomLeft;
	TImage *ImageBottomRight;
	TImage *ImageBottom;
	TMenuItem *PopupMenuAlwaysontop;
	TMenuItem *PopupMenuConsole;
        TImage *ImageFullscreen;
	TLabel *LabelStatus;
	TMenuItem *PopupMenuFullScreen;
	TMenuItem *PopupMenuSkin;
	TMenuItem *PopupMenuSkinReload;
	TMenuItem *PopupMenuSkinLeet;
        TMenuItem *PopupMenuSkinMetal;
	TMenuItem *PopupMenuLight;
        TLabel *LabelTime;
        TTimer *Timer;
        TMenuItem *PopupMenuOpenMedia;
        TOpenDialog *OpenDialog;
        TImage *ImageSlider;
        TImage *ImageSeeker;
        TImage *ImageVolumeSlider;
        TImage *ImageVolumeSeeker;
        TMenuItem *PopupMenuControls;
        TMenuItem *PopupMenuZoom1;
        TMenuItem *PopupMenuZoom2;
        TMenuItem *PopupMenuZoomX1;
        TMenuItem *PopupMenuZoomX2;
        TMenuItem *PopupMenuZoomY1;
        TMenuItem *PopupMenuZoomY2;
        TMenuItem *PopupMenuRate1;
        TMenuItem *PopupMenuRate2;
        TMenuItem *PopupMenuRemoteMedia;
        TClientSocket *ClientSocketTCP;
        TNMUDP *SocketUDP1;
        TNMUDP *SocketUDP2;
        TNMUDP *SocketUDP3;
        TNMUDP *SocketUDP4;
	TImage *ImageNext;
	TImage *ImagePrev;
	TMenuItem *PopuMenuZoomReset;

	void __fastcall Console(AnsiString s);
	void __fastcall Refresh();
	void __fastcall Move();
	void __fastcall SetStatus(short s);
	void __fastcall SwitchLight(bool v);
	void __fastcall SwitchFullScreen(bool v);
	void __fastcall SwitchMaximize(bool v);
	void __fastcall SwitchAlwaysOnTop(bool v);
	void __fastcall SwitchConsole(bool v);
	void __fastcall LoadSkin(AnsiString s);
	bool __fastcall LoadSkinElement(AnsiString s, AnsiString skin);
	void __fastcall Open();
	void __fastcall Close();
	void __fastcall Play();
	void __fastcall Pause();
	void __fastcall Stop();
	void __fastcall Prev();
	void __fastcall Next();
	void __fastcall Seek(LONGLONG pos);
	void __fastcall OpenMedia();
	void __fastcall OpenRemoteMedia();
	void __fastcall EndOfMedia();
	void __fastcall UpdateRect();
	void __fastcall UpdateSlider();
	void __fastcall UpdateVolume();
        void __fastcall StopTimer();
        void __fastcall StartTimer();
        bool __fastcall UpdateTitle();

      	void __fastcall SetDuration(LONGLONG duration);
      	void __fastcall SetPosition(LONGLONG position);

	void __fastcall FormMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall ImagePlayClick(TObject *Sender);
	void __fastcall ImagePlayMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageExitClick(TObject *Sender);
	void __fastcall ImageExitMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageStopClick(TObject *Sender);
	void __fastcall ImageStopMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImagePauseClick(TObject *Sender);
	void __fastcall ImagePauseMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageResizeMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageMouseDown(TObject *Sender, TMouseButton Button,
		  TShiftState Shift, int X, int Y);
	void __fastcall ImageTopMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageTopRightMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall ImageTopRightMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageTopMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageMouseMove(TObject *Sender, TShiftState Shift, int X,
          int Y);
	void __fastcall ImageTopLeftMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageTopLeftMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall PopupMenuExitClick(TObject *Sender);
	void __fastcall PopupMenuAboutClick(TObject *Sender);
	void __fastcall ImageReduceClick(TObject *Sender);
	void __fastcall ImageReduceMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageRightMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageLeftMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageBottomLeftMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageBottomMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageBottomRightMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageBottomMouseDown(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
	void __fastcall ImageBottomLeftMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall ImageBottomRightMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
	void __fastcall PopupMenuAlwaysontopClick(TObject *Sender);
	void __fastcall PopupMenuPopup(TObject *Sender);
	void __fastcall PopupMenuConsoleClick(TObject *Sender);
	void __fastcall ImageFullscreenClick(TObject *Sender);
	void __fastcall ImageFullscreenMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageDblClick(TObject *Sender);
	void __fastcall ImageTopDblClick(TObject *Sender);
	void __fastcall ImageTopLeftDblClick(TObject *Sender);
	void __fastcall FormKeyPress(TObject *Sender, char &Key);
	void __fastcall PopupMenuFullScreenClick(TObject *Sender);
	void __fastcall PopupMenuSkinReloadClick(TObject *Sender);
	void __fastcall PopupMenuSkinLeetClick(TObject *Sender);
	void __fastcall PopupMenuSkinMetalClick(TObject *Sender);
	void __fastcall FormDestroy(TObject *Sender);
	void __fastcall PopupMenuLightClick(TObject *Sender);
	void __fastcall FormClose(TObject *Sender, TCloseAction &Action);
        void __fastcall TimerTimer(TObject *Sender);
        void __fastcall PopupMenuOpenMediaClick(TObject *Sender);
        void __fastcall PanelDisplayDblClick(TObject *Sender);
        void __fastcall PanelDisplayMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall PanelDisplayClick(TObject *Sender);
        void __fastcall ImageSeekerMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ImageSeekerMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall ImageSeekerMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ImageVolumeSeekerMouseDown(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall ImageVolumeSeekerMouseMove(TObject *Sender,
          TShiftState Shift, int X, int Y);
        void __fastcall ImageVolumeSeekerMouseUp(TObject *Sender,
          TMouseButton Button, TShiftState Shift, int X, int Y);
        void __fastcall FormMouseWheelUp(TObject *Sender,
          TShiftState Shift, TPoint &MousePos, bool &Handled);
        void __fastcall FormMouseWheelDown(TObject *Sender,
          TShiftState Shift, TPoint &MousePos, bool &Handled);
        void __fastcall FormKeyDown(TObject *Sender, WORD &Key,
          TShiftState Shift);
        void __fastcall FormShow(TObject *Sender);
        void __fastcall ImageSliderClick(TObject *Sender);
        void __fastcall ClientSocketTCPRead(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocketTCPConnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocketTCPConnecting(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocketTCPDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall ClientSocketTCPError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
        void __fastcall ClientSocketTCPLookup(TObject *Sender,
          TCustomWinSocket *Socket);
        void __fastcall SocketUDP1DataReceived(TComponent *Sender,
          int NumberBytes, AnsiString FromIP, int Port);
        void __fastcall SocketUDP2DataReceived(TComponent *Sender,
          int NumberBytes, AnsiString FromIP, int Port);
        void __fastcall SocketUDP3DataReceived(TComponent *Sender,
          int NumberBytes, AnsiString FromIP, int Port);
        void __fastcall SocketUDP4DataReceived(TComponent *Sender,
          int NumberBytes, AnsiString FromIP, int Port);
        void __fastcall PopupMenuRemoteMediaClick(TObject *Sender);
	void __fastcall FormResize(TObject *Sender);
	void __fastcall ImageNextClick(TObject *Sender);
	void __fastcall ImagePrevClick(TObject *Sender);
	void __fastcall ImagePrevMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall ImageNextMouseMove(TObject *Sender, TShiftState Shift,
          int X, int Y);
	void __fastcall PopuMenuZoomResetClick(TObject *Sender);
	void __fastcall PopupMenuZoom1Click(TObject *Sender);
	void __fastcall PopupMenuZoom2Click(TObject *Sender);
	void __fastcall PopupMenuZoomX1Click(TObject *Sender);
	void __fastcall PopupMenuZoomX2Click(TObject *Sender);
	void __fastcall PopupMenuZoomY1Click(TObject *Sender);
	void __fastcall PopupMenuZoomY2Click(TObject *Sender);
	void __fastcall PopupMenuRate1Click(TObject *Sender);
	void __fastcall PopupMenuRate2Click(TObject *Sender);
private:	// Dclarations de l'utilisateur
	Graphics::TBitmap *BitmapBg;
	Graphics::TBitmap *BitmapPlay;
	Graphics::TBitmap *BitmapPlayHover;
	Graphics::TBitmap *BitmapPlayClick;
	Graphics::TBitmap *BitmapExit;
	Graphics::TBitmap *BitmapExitHover;
	Graphics::TBitmap *BitmapStop;
	Graphics::TBitmap *BitmapStopHover;
	Graphics::TBitmap *BitmapStopClick;
	Graphics::TBitmap *BitmapPause;
	Graphics::TBitmap *BitmapPauseHover;
	Graphics::TBitmap *BitmapPauseClick;
	Graphics::TBitmap *BitmapTop;
	Graphics::TBitmap *BitmapTopRight;
	Graphics::TBitmap *BitmapTopLeft;
	Graphics::TBitmap *BitmapReduce;
	Graphics::TBitmap *BitmapReduceHover;
	Graphics::TBitmap *BitmapRight;
	Graphics::TBitmap *BitmapLeft;
	Graphics::TBitmap *BitmapBottomLeft;
	Graphics::TBitmap *BitmapBottomRight;
	Graphics::TBitmap *BitmapBottom;
	Graphics::TBitmap *BitmapFullscreen;
	Graphics::TBitmap *BitmapFullscreenHover;
	Graphics::TBitmap *BitmapSlider;
	Graphics::TBitmap *BitmapSeeker;
	Graphics::TBitmap *BitmapVolumeSlider;
	Graphics::TBitmap *BitmapVolumeSeeker;
	Graphics::TBitmap *BitmapNext;
	Graphics::TBitmap *BitmapNextHover;
	Graphics::TBitmap *BitmapNextClick;
	Graphics::TBitmap *BitmapPrev;
	Graphics::TBitmap *BitmapPrevHover;
	Graphics::TBitmap *BitmapPrevClick;

	TIniFile *ini;  // Fichier ini
        EzThread *ezt;  // Thread de lecture
        EzRtsp *ezr;    // Thread RTSP

        // TrayIcon
	TIcon *icone;       // Icne
	NOTIFYICONDATA ni;  // Data de l'icne

        // Strings
	AnsiString media_url,buffer,tmps,rtsp_server,rtsp_file,rtsp_port;

        // Buffers
        char *buffer1,*buffer2,*buffer3,*buffer4;
	int j;                       // Tmp octets reus
	int bytes_received;          // Octets reus

        // Options
	bool tmp, opt_light, opt_maximize, opt_fullscreen, opt_alwaysontop, opt_console;
	AnsiString opt_skin;
	LPWSTR lpwstrLocalFile;
	LPTSTR lpszTitle;
	unsigned short status;
	short ez_mode;               // Mode de lecture : locale ou rtsp
	short mouseover;             // Quel est le contrle survol
	short last_mouseover;        // Dernier contrle survol

        // Sliders
        short mouse_pos_origin;      // Position d'origine de la souris pour les sliders
        short seeker_pos_origin;     // Position d'origine du seeker sur le slider
        bool drag;                   // True = la souris dplace un slider
        LONGLONG position;           // Position temporaire pour les calculs

        // Position/Dure
	LONGLONG media_duration;     // Dure totale du media
	LONGLONG media_position;     // Position temporelle sur le media
        short media_duration_s,media_duration_m; // Dure en minutes/secondes
        short media_position_s,media_position_m; // Position en minutes/secondes
        short seeker_min,seeker_max,seeker_pos; // Seeker de dure
        float media_pos;             // Position sur le media

        // Volume
        short volume_seeker_min,volume_seeker_max,volume_seeker_pos;
        float media_volume_pos;      // Position du volume sur le slider
        short media_volume_pourcent; // Volume en pourcentage
        long media_volume;           // Volume logarithmique (de -10000 silence  0 maximum)
        long media_balance;          // Balance logarithmique (de -10000 gauche  10000 droite)

public:		// Dclarations de l'utilisateur
	__fastcall TForm1(TComponent* Owner);
};

//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;

//---------------------------------------------------------------------------
#endif
