//---------------------------------------------------------------------------

#ifndef ezrtspH
#define ezrtspH
//---------------------------------------------------------------------------
#define EZ_RTSP_CONNECTED 10
#define EZ_RTSP_CLEAN 11
#define EZ_RTSP_INIT 12
#define EZ_RTSP_DESCRIBE 13
#define EZ_RTSP_WAIT_DESCRIBE 14
#define EZ_RTSP_RECEIVED_DESCRIBE 15
#define EZ_RTSP_SETUP_AUDIO 16
#define EZ_RTSP_SETUP_VIDEO 17
#define EZ_RTSP_SETUP_WAIT_AUDIO 18
#define EZ_RTSP_SETUP_RECEIVED_AUDIO 19
#define EZ_RTSP_SETUP_WAIT_VIDEO 20
#define EZ_RTSP_SETUP_RECEIVED_VIDEO 21
#define EZ_RTSP_SETUP_DONE 22
#define EZ_RTSP_PLAY 30
#define EZ_RTSP_PAUSE 40
#define EZ_RTSP_TEARDOWN 50
#define EZ_RTSP_TEARDOWN_WAIT 51
#define EZ_RTSP_TEARDOWN_RECEIVED 52
#define EZ_RTSP_WAIT 100
#define EZ_RTSP_DOWN 666 

//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <ScktComp.hpp>
#include <NMUDP.hpp>
//---------------------------------------------------------------------------
class EzRtsp : public TThread
{
private:
        // RTSP
        bool running;
        unsigned short status;
	int cseq, session, i;
        int udp_port1,udp_port2,udp_port3,udp_port4; // Ports UDP

        AnsiString media_url;    // URL du media
        AnsiString media_file;   // Fichier pour le dialogue rtsp
        AnsiString media_host;   // Host pour le dialogue rtsp

        AnsiString buffer;       // Buffer d'envoi
        AnsiString rbuffer;      // Buffer de rception

        AnsiString content_base; // Content-base
        AnsiString media_range;  // Range
        AnsiString media_stream; // Temporaire
        AnsiString media_session;     // Session

        short media_audio_trackid;              // TrackID audio
        short media_video_trackid;              // TrackID vido
        AnsiString media_audio_transport;       // Transport audio
        AnsiString media_audio_source;          // Adresse source audio
        AnsiString media_audio_server_port;     // Ports serveur audio
        AnsiString media_video_transport;       // Transport vido
        AnsiString media_video_source;          // Adresse source vido
        AnsiString media_video_server_port;     // Ports serveur pour la vido

        TClientSocket* Sock;
        void __fastcall Console(AnsiString s);
        bool __fastcall Parse();
        AnsiString __fastcall ParseValue(AnsiString k, char c);
        AnsiString __fastcall ParseSubValue(AnsiString text, AnsiString k, char c);
        void __fastcall Send(AnsiString s);

protected:
        void __fastcall Execute();

public:
        __fastcall EzRtsp(bool CreateSuspended);
        __fastcall ~EzRtsp();
        bool __fastcall Init();
        void __fastcall SetURL(AnsiString url);
        void __fastcall Received(AnsiString s);
        void __fastcall Connect();
        void __fastcall Teardown();
        void __fastcall Pause();
        void __fastcall Play();
        void __fastcall SetSocket(TClientSocket *ts);
        void __fastcall SetFile(AnsiString s);
        void __fastcall SetHost(AnsiString s);
};
//---------------------------------------------------------------------------
#endif
