//---------------------------------------------------------------------------
#ifndef ezthreadH
#define ezthreadH
//---------------------------------------------------------------------------
#define EZ_MEDIA_STOPPED 0
#define EZ_MEDIA_INIT 1
#define EZ_MEDIA_READY 2
#define EZ_MEDIA_PLAYING 3
#define EZ_MEDIA_PAUSED 4
#define EZ_MEDIA_CLOSED 5
//---------------------------------------------------------------------------
#include <dshow.h>
#include <vmr9.h>
#include <strmif.h>
//---------------------------------------------------------------------------
#include <Classes.hpp>
//---------------------------------------------------------------------------
class EzThread : public TThread
{            
private:
        // Structures Media
        IGraphBuilder *pGraph;
        IMediaControl *pControl;
        IBasicAudio   *pAudio;
        IMediaSeeking *pSeek;
        IMediaEvent   *pEvent;
        IVMRWindowlessControl9 *pWc;
        IBaseFilter   *VideoSourceFilter; 

        // Structures de contrle du media
        HWND hwnd; // Handle o projeter
        HRESULT hr; // Rsultats
        long evCode; // Code vnement
        long media_width, media_height; // Dimensions de la source
        OAFilterState state; // Etat de lecture

        LONGLONG media_duree; // Dure
        LONGLONG media_position; // Position dans le media

        LONGLONG position_lecture, position_stop; // Position
        long position_seek; // Pour seeker
        double media_rate; // Vitesse lecture
        long timeout; // Timeout de lecture
        RECT rcSrc, rcDest; // Rectangle video

        // Contrle
        short status;
        short decalx,decaly;
        short ratio;
        long volume, lastvolume;
        bool mute;

protected:
        void __fastcall Execute();
public:
        __fastcall EzThread(bool CreateSuspended);
        void __fastcall Console(AnsiString s);
        bool __fastcall Init();
        bool __fastcall OpenFile(LPCWSTR lpwstrFile);
        bool __fastcall Close();
        bool __fastcall Play();
        bool __fastcall Pause();
        bool __fastcall Stop();
        bool __fastcall Seek(LONGLONG pos);
        bool __fastcall UpdateRect();
        bool __fastcall RectZoomX(short v);
        bool __fastcall RectZoomY(short v);
        bool __fastcall SetAudio(long volume, long balance);
        bool __fastcall ReInit();
        bool __fastcall UpdateRate(float f);
        bool __fastcall Mute();
};

#ifndef OUR_GUID_ENTRY
    #define OUR_GUID_ENTRY(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8) \
    DEFINE_GUID(name, l, w1, w2, b1, b2, b3, b4, b5, b6, b7, b8);
#endif

OUR_GUID_ENTRY(CLSID_VideoMixingRenderer9,
0x51b4abf3, 0x748f, 0x4e3b, 0xa2, 0x76, 0xc8, 0x28, 0x33, 0x0e, 0x92, 0x6a)


//---------------------------------------------------------------------------
#endif
